/* GCC */

#include <stdio.h>

char grid[9]; //  :       0, 1  2,
              //     3, 4  5,      6, 7  8

//  ,      ,   
//    grid  center,     center-delta  center+delta:
bool checkLine(int center, int delta)
{
    return grid[center] != '.'
           && grid[center - delta] == grid[center]
           && grid[center + delta] == grid[center];
}

int main()
{
    freopen("ttt.in", "r", stdin);
    freopen("ttt.out", "w", stdout);

    //          :
    int xCnt = 0, oCnt = 0;
    for (int i = 0; i < 3; i++)
    {
        for (int j = 0; j < 3; j++)
        {
            char c;
            scanf("%c", &c);
            grid[i * 3 + j] = c;
            if (c == 'x')
                xCnt++;
            if (c == 'o')
                oCnt++;
        }
        scanf("\n");
    }

    for (int i = 1; i <= 4; i++)
        if (checkLine(4, i) // ˳,      
            || checkLine(i * 2 - 1, i % 3 == 1 ? 1 : 3)) //  
        {
            //     ,  ,    :
            printf("%c\n", xCnt > oCnt ? 'x' : 'o');
            return 0;
        }

    //     , ,     :
    printf("%c\n", xCnt + oCnt < 9 ? '.' : '=');
}
