/* GCC */

#include <cstdio>
#include <cstdlib>
#include <algorithm>
#include <vector>
#include <string>
#include <utility>
#include <cstring>
using namespace std;

#ifdef MY_DEBUG
#define NAME "debug2"
#define _GLIBCXX_DEBUG
#else
#define NAME "bac"
#endif

int ans[5][5] = {};
int tr[5][5] = {};
char nums[9010][5];
bool is_nums[10000] = {};
bool used1[4] = {}, used2[4] = {};
int n;

void count(int& c, int& b, char t[], char pt[])
{
    b = 0, c = 0;
    memset(used1, 0, 4);
    memset(used2, 0, 4);
    for (int j = 0; j < 4; ++j)
        if (t[j] == pt[j])
            ++b, used1[j] = used2[j] = true;

    for (int k = 0; k < 4; ++k)
        for (int j = 0; j < 4; ++j)
            if (t[k] == pt[j] && !used1[k] && !used2[j])
                ++c, used1[k] = used2[j] = true;
}

void solve()
{
    char t[5];
//    char pt[5];
//    bool used1[4] = {}, used2[4] = {};
    int b, c;
    for (int i = 9999; i >= 1000; --i)
    {
        if (is_nums[i])
            continue;
        memset(tr, 0, 5*5*sizeof(int));
        sprintf(t, "%d", i);

        for (int cur_n = 0; cur_n < n; ++cur_n)
        {
            count(c, b, t, nums[cur_n]);
            tr[b][c]++;
            if (tr[b][c] > ans[b][c])
                break;
            //printf("%s\n", pt);
        }
        if (memcmp(tr, ans, 25*sizeof(int)) == 0) {
            printf("%s\n", t);
            return;
        }
    }


}

int main()
{
    freopen(NAME ".in", "r", stdin);
    freopen(NAME ".out", "w", stdout);

    scanf("%d", &n);

    for (int i = 0; i < n; ++i)
    {
        scanf("%s\n", &nums[i][0]);
    }

    for (int i = 0; i < n; ++i)
    {
        is_nums[atoi(nums[i])] = true;
    }

    for (int i = 0; i < n; ++i)
    {
        int b, c;
        scanf(" %d %d", &b, &c);
        ++ans[b][c];
    }

    solve();

    return 0;
}
