/* GCC */

#include <stdio.h>
#include <algorithm>
#include <vector>
#include <queue>
#include <map>

using namespace std;

#define sz 3 // / 
#define n 9 // ʳ :  sz^2
#define target 123456780 // ,   

//       (digits),  , 
//      ( k    0  n-1), 
//  ,  ,  ( z    0  n-1);
//  ,   ,    :
inline int moveDigit(int digits[], int k, int z)
{
    //  :
    digits[z] = digits[k];
    digits[k] = 0;

    //  :
    int result = 0;
    for (int i = 0; i < n; i++)
        result = result * 10 + digits[i];

    //   ,     :
    digits[k] = digits[z];
    digits[z] = 0;

    return result;
}

//  -   ,         :
inline vector<int> getMoves(int pos)
{
    int digits[n]; //   pos
    int zero; //    digits  0 ( )
    for (int i = n - 1; i >= 0; i--) //  digits   zero
    {
        digits[i] = pos % 10;
        pos /= 10;
        if (digits[i] == 0)
            zero = i;
    }

    vector<int> result; //          

    //       ,    :
    if (zero % sz != 0)
        result.push_back(moveDigit(digits, zero - 1, zero));

    //       ,    :
    if ((zero + 1) % sz != 0)
        result.push_back(moveDigit(digits, zero + 1, zero));

    //       ,    :
    if (zero >= sz)
        result.push_back(moveDigit(digits, zero - sz, zero));

    //       ,    :
    if (zero < n - sz)
        result.push_back(moveDigit(digits, zero + sz, zero));

    return result;
}

int main()
{
    freopen("eight.in", "r", stdin);
    freopen("eight.out", "w", stdout);

    //   :
    int start = 0;
    for (int i = 0; i < n; i++)
    {
        int d;
        scanf("%d", &d);
        start = start * 10 + d;
    }

    queue<int> q; //    ,      
    q.push(start);

    map<int, int> m; // m[pos]   ,      
    m[start] = 0;    // pos  

    while (! q.empty()) //     
    {
        int cur = q.front(); //         
        q.pop();
        int distance = m[cur] + 1; // ³       ,
                                   //         
        vector<int> moves = getMoves(cur);
        for (int i = 0; i < moves.size(); i++) //    
            if (m.count(moves[i]) == 0) //      ,
            {
                m[moves[i]] = distance; //   
                q.push(moves[i]);       //       
            }
    }

    //     ,   -1,
    //         m:
    printf("%d\n", m.count(target) == 0 ? -1 : m[target]);
}
